<?php

namespace Ulmus\Repository;

use Ulmus\{Common\EntityResolver, ConnectionAdapter, MysqlQueryBuilder, Repository, Query, Ulmus};

class MysqlRepository extends Repository {

    public function pragma(/*object|Stringable*/ $pragma, $argument = null, bool $callable = false) : self
    {
        $this->queryBuilder->pragma($pragma, $argument, $callable);

        return $this;
    }

    public function createSqlQuery() : self
    {
        if ( null === $this->queryBuilder->getFragment(Query\Engine::class) ) {
            if ( $engine = $this->entityResolver->tableAnnotation()->engine ?? $this->entityResolver->databaseAdapter()->adapter()->defaultEngine() ) {
                $this->queryBuilder->engine($engine);
            }
        }

        return parent::createSqlQuery();
    }
}
