<?php

namespace Ulmus\SearchRequest;

use Psr\Http\Message\ServerRequestInterface;
use Ulmus\Repository;

class SearchRequest implements SearchRequestInterface
{
    use SearchRequestPaginationTrait, SearchRequestFromRequestTrait;

    public function filter(Repository $repository) : Repository
    {
        return $repository;
    }

    public function wheres() : iterable
    {
        return array_filter($this->wheres + [
        ], fn($i) => ! is_null($i) ) + [ ];
    }

    public function likes(): iterable
    {
        return array_filter($this->likes + [
        ], fn($i) => ! is_null($i) ) + [];
    }

    public function groups(): iterable
    {
        return array_filter($this->groups + [
        ], fn($e) => ! is_null($e)  && $e !== "" );
    }

    public function orders(): iterable
    {
        return array_filter($this->orders + [
        ], fn($e) => ! is_null($e)  && $e !== "" );
    }

}